package net.sf.sido;

import com.google.common.base.Predicate;

public interface Property<T> {

	T apply(DataObject o, T value);

	Predicate<T> getConstraint();

	T getDefaultValue(boolean deep);

	DataType getHolderType();

	MetaInfo getMetaInfo();

	String getName();

	Class<? super T> getType();

	boolean isArray();

	boolean isDO();

	boolean isExtension();

	boolean isNullable();

	boolean isSimple();

    boolean isIndexedArray();
}
