package net.sf.sido.io;

import net.sf.sido.DataFactory;

import java.util.concurrent.atomic.AtomicReference;

public class SiDODeserializerContext {

    private static final AtomicReference<DataFactory> globalDataFactory = new AtomicReference<DataFactory>();
    private static final ThreadLocal<DataFactory> localDataFactory = new InheritableThreadLocal<DataFactory>();

    public static void setGlobalDataFactory(DataFactory dataFactory) {
        globalDataFactory.set(dataFactory);
    }

    public static void setLocalDataFactory(DataFactory dataFactory) {
        localDataFactory.set(dataFactory);
    }

    public static DataFactory getDataFactory () {
        DataFactory dataFactory = localDataFactory.get();
        if (dataFactory == null) {
            dataFactory = globalDataFactory.get();
            if (dataFactory == null) {
                throw new IllegalStateException("No DataFactory context has been set.");
            }
        }
        return dataFactory;
    }
    
}
